/* deux locomotives en voie unique sur le circuit imprimé du V&V
 * croisement en gare intermédiaire
 * msport 1/5/2022
 * Utilisation de la bibliothèque DCCpp sur la voie MAIN
 * le V&V doit être alimenté en 12V pour que SEL fonctionne, du à un partage de l'entrée A2 avec la mesure de tension
*/

#include <DCCpp.h>

char * VERS = "V&V x2 0.1 ";
char* titre[]={"V&V x2 0.1 ", "            ", "Positions ", "Arret      ", "Lire adresse", "codeur     ", "AUTOMATE  ", "ARRETE      "};

// Include the Bounce2 library found here : https://github.com/thomasfredericks/Bounce2
#include <Bounce2.h>
Bounce debouncer1 = Bounce(); // Instantiate  Bounce objects
Bounce debouncer2 = Bounce();
Bounce debouncer3 = Bounce();
Bounce debouncer4 = Bounce();
#include <Wire.h>
#include "SSD1306Ascii.h"
#include "SSD1306AsciiWire.h"
#define I2C_ADDRESS 0x3C // 0X3C+SA0 - 0x3C or 0x3D
SSD1306AsciiWire oled;
#define MOTOR_SHIELD_TYPE   0     // LMD18200 ou L6203 
#define COMM_INTERFACE   0

  
#define  PIN_GARE1           5     
#define  PIN_ZONEA           6    
#define  PIN_ZONEB           7    
#define  PIN_ZONEC           8    
#define  PIN_GARE2           9  
#define  LEDROUGE           11    // led rouge 
#define VOLTAGE  A2               // voltage sensor
float gtension=0;

int debug = 0; // set to 1 to show debug info on serial port 
unsigned long temps;
unsigned long temps2;
unsigned long tempsA = 5000;  // temps d'attente en gare	 
unsigned long tempsD = 5000;
unsigned long delta_t = 250;  // le pas en ms pour changer la vitesse
int i;
int j;
int adresseLoco1 = 68;
int adresseLoco2 = 19;
int etatLoco1 = 99;
int etatLoco2 = 99;
bool sens1 = 1;            // Loco1 part en avant
bool sens2 = 1;            // poser Loco2 en sens inverse
bool arretee1 = 0;
bool arretee2 = 0;

FunctionsState LocoFunctions;

bool Gare1;
bool ZoneA;
bool ZoneB;
bool ZoneC;
bool Gare2;

int vitesse1;
int vitesse2;
int vitesse_max1 = 20;
int vitesse_max2 = 20;
int vitesse_min1 = 8;
int vitesse_min2 = 8;
bool sens_1 = 1;
bool sens_2 = 0;
int Address =  2 ; // accessoire 5
byte SubAddress = 0;  // accessoire 5  +1 => 6 
bool Activate = 0 ; // direct

void feux(bool lumiere, int adresse_dcc) {
  DCCpp::setFunctionsMain(2, adresse_dcc, LocoFunctions); // registre 1 pour la loco et registre 2 pour la fonction
  if (lumiere) {
    LocoFunctions.activate(0);
  } else {
    LocoFunctions.inactivate(0);
  }
}

void majOled() {
  oled.setCursor(0, 4); // start of 3rd line
  oled.print("Loco1 : ");   oled.print(etatLoco1); oled.println(" ");   
  oled.setCursor(0, 6); // start of 4th line
  oled.print("Loco2 : ");   oled.print(etatLoco2); oled.println(" ");   
}

void setup() {
  debouncer1.attach(17, INPUT_PULLUP ); // UP rouge A3 pour pcb C6 (D12 pour pcb C41)
  debouncer1.interval(5); // interval in ms
  debouncer2.attach(13, INPUT_PULLUP ); // DOWN noir
  debouncer2.interval(5); // interval in ms
  debouncer3.attach(16, INPUT_PULLUP ); // SEL A2 vert
  debouncer3.interval(5); // interval in ms
  debouncer4.attach(15, INPUT_PULLUP ); // coder button A1
  debouncer4.interval(5); // interval in ms
  Wire.begin();         
  oled.begin(&Adafruit128x64, I2C_ADDRESS);
  oled.set400kHz();
  oled.setFont(System5x7);  
  oled.set2X();
  oled.clear();
  oled.setCursor(0, 0); // start of  
  oled.println(VERS); 
  Serial.begin( 115200 );
  DCCpp::begin(); //
  DCCpp::beginMain(UNDEFINED_PIN, 10, 3, 14); // pour voie Main 
  DCCpp::powerOn();
  for ( int i = 5; i < 10 ; i++ ) {
    pinMode(i, INPUT_PULLUP);
  }
  pinMode(LEDROUGE, OUTPUT);
  pinMode(VOLTAGE, INPUT);
  gtension = analogRead(VOLTAGE); // lecture tension alim
  gtension = gtension * 0.033;
  oled.setCursor(0,6);                        // 4eme ligne
  oled.print((int)gtension); 
  debouncer4.update(); // coder button  
  int value4 = debouncer4.read();
  if ( debouncer4.fell() ) { 
    oled.setCursor(0, 0);
    oled.print(titre[4]); 
    oled.setCursor(0, 2); // start of 2rd line
    oled.print("           ");
    oled.setCursor(0, 2); // start of 1st line  
    int adLoco = DCCpp::identifyLocoIdMain();
    oled.print("Loco1#= "); oled.print(adLoco);
    adresseLoco1 = adLoco;     
  } 
  
  DCCpp ::setAccessory(Address, SubAddress, Activate);        // 1ere aiguille directe    Addresse 5   
  delay (500);
  DCCpp ::setAccessory(Address, SubAddress + 1 , ! Activate);        // 2e aiguille déviée    Addresse 6
  delay (500);
  DCCpp ::setAccessory(Address, SubAddress, ! Activate);        // 1ere aiguille directe vers A    Addresse 5   
  delay (500);
  DCCpp ::setAccessory(Address, SubAddress + 1 , Activate);        // 2e aiguille déviée vers C   Addresse 6 
  delay (500);
  
  } // END SETUP


// ============================= LOOP ==============================  

void loop() {
  DCCpp::loop(); 
  majOled();
  if (debug == 1){  // modif
    Serial.print("Etat Locos : ");
    Serial.print(etatLoco1);
    Serial.print(" : ");
    Serial.println(etatLoco2);
    }   
  
  debouncer3.update(); // SEL vert lancement 
  int value3 = debouncer3.read();
  if ( debouncer3.fell() ) {
    DCCpp::powerOn(); 
    oled.setCursor(0, 0); // start of 1st line demarrage
    oled.print(titre[1]);
    oled.setCursor(0, 0); // start of 1st line demarrage
    oled.print(titre[2]); 
    etatLoco1 = -1 ;  
    etatLoco2 = -1 ;  
    delay (500);
    DCCpp ::setAccessory(Address, SubAddress, ! Activate);         // 1ere aiguille directe vers A    Addresse 5 
    delay (500);
    DCCpp ::setAccessory(Address, SubAddress + 1 , Activate);       // 2e aiguille déviée vers C   Addresse 6 
    digitalWrite(LEDROUGE, HIGH);
  } 
   
  debouncer1.update(); // UP rouge stop
  int value1 = debouncer1.read();
  if ( debouncer1.fell() ) { 
    oled.setCursor(0, 0); // start of 1st line arret 
    oled.print(titre[7]); 
    etatLoco1 = 99 ; 
    etatLoco2 = 99 ; 
    delay (500);
    DCCpp ::setAccessory(Address, SubAddress, ! Activate);        // 1ere aiguille directe    Addresse 5   
    delay (500);
    DCCpp ::setAccessory(Address, SubAddress + 1 , Activate);        // 2e aiguille déviée    Addresse 6
//    DCCpp::powerOff(); 
    digitalWrite(LEDROUGE, LOW);
  }
  
  debouncer2.update(); // DOWN noir lire adresse Loco2
  int value2 = debouncer2.read();
  if ( debouncer2.fell() ) { 
    oled.setCursor(0, 0);
    oled.print(titre[4]); 
    oled.setCursor(0, 2); // start of 2rd line
    oled.print("           ");
    oled.setCursor(0, 2); // start of 2rd line  
    int adLoco = DCCpp::identifyLocoIdMain();
    oled.print("Loco2#= "); oled.print(adLoco);
    adresseLoco2 = adLoco;     
  }
  
  debouncer4.update(); // coder button  stop
  int value4 = debouncer4.read();
  if ( debouncer4.fell() ) { 
    oled.setCursor(0, 0); // start of 1st line arret 
    oled.print(titre[3]); 
    etatLoco1 = 99 ; 
    etatLoco2 = 99 ; 
    DCCpp::powerOff();  
  } 

// ============================= LOCO 1 ==============================  

// etatLoco1 = 0
  if ( etatLoco1 == -1 ) {    // ==== etat -1 ==== L'AUTOMATE EST LANCE 
    majOled();
    oled.setCursor(0, 0); // start of 1st line arret 
    oled.print(titre[6]); 
    if ( vitesse1 < vitesse_min1 ) {                     // on avance GARE1
      if (millis()> ( temps + delta_t)){
        temps = millis();
        vitesse1++ ;
        arretee1 = false ;
        DCCpp::setSpeedMain(1, adresseLoco1, 128, vitesse1, sens1); 
      }
    }
    else  etatLoco1 = 0  ;  
  } 
  if ( ( etatLoco1 == 0 ) || ( etatLoco1 == 1 ) ) {    // ==== etat 0 ==== ON VA S'ARRETER GARE1
    Gare1 = ! digitalRead(PIN_GARE1);          
    if ( Gare1 ) {etatLoco1 = 1;}    //  on est arrivé Gare1
    if ( etatLoco1 == 1 ) {            // on est passé sur PIN_GARE1
      if ( vitesse1 > 0 ) {
        if (millis()> ( temps + delta_t)){
          temps = millis();
          vitesse1-- ;
          DCCpp::setSpeedMain(1, adresseLoco1, 128, vitesse1, sens1); 
        }
      }
      else { arretee1 = true ;}    
    }
    if ( arretee1 ) {
      if ( millis() < ( temps + tempsA )){ // on attend tempsA
      }
      else {                               //  tempsA écoulé, on repart -> ZONEA
        if ( etatLoco2 < 3 ) { 
          etatLoco1 = 2 ;
          DCCpp ::setAccessory(Address, SubAddress ,  ! Activate);        // 1e aiguille directe    Addresse 5
        }
        Gare1 = ! digitalRead(PIN_GARE1); // ==== fin etat 1 ==== ON S'EST ARRETE APRES GARE 1
      }
    }                          
  }  
      
      // etatLoco1 = 2  
  if ( ( etatLoco1 == 2 ) || ( etatLoco1 == 3 ) ) {   // ==== etat 2 ==== GARE1 -> ZONEA    ON REPART APRES GARE 1
    majOled();
    oled.setCursor(0, 0); // start of 1st line arret 
    oled.print(titre[6]); 
    if ( etatLoco1 == 2 ) {                             // on n'est pas encore  sur PIN_ZONEA
      if ( vitesse1 < vitesse_max1 ) {                     // on accélère
        if (millis()> ( temps + delta_t)){
          temps = millis();
          vitesse1++ ;
          arretee1 = false ;
          DCCpp::setSpeedMain(1, adresseLoco1, 128, vitesse1, sens1); 
        }
      }
    }
    ZoneA = ! digitalRead(PIN_ZONEA);    
    if ( ZoneA ) {etatLoco1 = 3;}
    if ( etatLoco1 == 3 ) {                        // on est passé sur PIN_ZONEA
      if ( vitesse1 > 0 ) {
        if (millis()> ( temps + delta_t)){
          temps = millis();
          vitesse1-- ;
          DCCpp::setSpeedMain(1, adresseLoco1, 128, vitesse1, sens1); 
        }
      }
      else { arretee1 = true ;}    
    }
    if ( arretee1 ) {
      if ( millis() < ( temps + tempsA )){ // on attend tempsA
      }
      else {                               //  tempsA écoulé, on repart -> GARE2
          if ( etatLoco2 >= 3 ) { 
            etatLoco1 = 4 ;
            DCCpp ::setAccessory(Address, SubAddress + 1 , ! Activate);       // 2e aiguille directe    Addresse 6
          } 
          ZoneA = ! digitalRead(PIN_ZONEA); // ==== etat 4 ==== ON S'EST ARRETE APRES PIN_ZONEA
      }
    } 
  }
// etatLoco1 = 4
  if  ( ( etatLoco1 == 4 ) || ( etatLoco1 == 5 ) ) {   // ==== etat 4 ==== ZONEA -> GARE2
    majOled();
    if ( etatLoco1 == 4 ) {                             // on n'est pas encore  sur PIN_GARE2
      if ( vitesse1 < vitesse_max1 ) {                     // on accélère
        if (millis()> ( temps + delta_t)){
          temps = millis();
          vitesse1++ ;
          arretee1 = false ;
          DCCpp::setSpeedMain(1, adresseLoco1, 128, vitesse1, sens1); 
        }   
      }
    }
    Gare2 = ! digitalRead(PIN_GARE2);
    if ( Gare2 ) { etatLoco1 = 5 ; }
    if ( etatLoco1 == 5 ) {                            // on est passé sur PIN_GARE2
      if ( vitesse1 > 0 ) {                            // on ralentit
        if (millis()> ( temps + delta_t)){
          temps = millis();
          vitesse1-- ;
          DCCpp::setSpeedMain(1, adresseLoco1, 128, vitesse1, sens1); 
        }
      }
      else { arretee1 = true ;}    
    }
    if ( arretee1 ) {
      if ( millis() < ( temps + tempsA )){ // on attend tempsA
      }
      else {                               //  tempsA écoulé, on repart -> ZONEC
        if ( etatLoco2 > 4 ) { 
           etatLoco1 = 6 ;
           DCCpp ::setAccessory(Address, SubAddress + 1 , Activate);       // 2e aiguille déviée vers C   Addresse 6
        } 
      }
    }
  }
  
//  etatLoco1 = 6
  if  ( ( etatLoco1 == 6 ) || ( etatLoco1 == 7 ) ) {   // ==== etat 5 ====  retour  GARE2 -> ZONEC
    majOled();
    if ( etatLoco1 == 6 ) {                             // on n'est pas encore
      if ( vitesse1 < vitesse_max1 ) {                     // on accélère
        if (millis()> ( temps + delta_t)){
          temps = millis();
          vitesse1++ ;
          arretee1 = false ;
          DCCpp::setSpeedMain(1, adresseLoco1, 128, vitesse1, ! sens1); 
        }
      }
    }
    ZoneC = ! digitalRead(PIN_ZONEC);
    if ( ZoneC ) { etatLoco1 = 7; }
    if ( etatLoco1 == 7 ) {                      // on est passé sur PIN_ZONEC et on s'arrête
      if ( vitesse1 > 0 ) {
        if (millis()> ( temps + delta_t)){
          temps = millis();
          vitesse1-- ;
          DCCpp::setSpeedMain(1, adresseLoco1, 128, vitesse1, ! sens1); 
        }
      }
      else { arretee1 = true ;}    
    }
    if ( arretee1 ) {
      if ( millis() < ( temps + tempsA )){ // on attend tempsA
      }
      else {                               //  tempsA écoulé, on repart -> GARE1
        if ( etatLoco2 > 6 ) { 
          etatLoco1 = 8 ;
          DCCpp ::setAccessory(Address, SubAddress ,  Activate);        // 1e aiguille déviée vers C      Addresse 5
        }
        ZoneC = ! digitalRead(PIN_ZONEC);
      }
    }          
  }


// etatLoco1 = 8
  if  ( ( etatLoco1 == 8 ) || ( etatLoco1 == 9 ) ) {   // ==== etat 8 ==== ZONEC -> GARE1
    majOled();
    if ( etatLoco1 == 8 ) {  
        Gare1 = ! digitalRead(PIN_GARE1) ; // ==== etat 8 ==== ON S'EST ARRETE APRES PIN_ZONEC ON REPART
        if ( vitesse1 < vitesse_max1 ) {
          if (millis()> ( temps + delta_t)){
            temps = millis();
            vitesse1++ ;
            arretee1 = false ;
            DCCpp::setSpeedMain(1, adresseLoco1, 128, vitesse1, ! sens1); 
          }   
       }
    }
    Gare1 = ! digitalRead(PIN_GARE1);// ==== etat 9 ==== ON EST ARRIVE PIN_GARE1 ON S'ARRETE
    if ( Gare1 ){etatLoco1 = 9 ;}          //  on est arrivé Gare1
    if ( etatLoco1 == 9 ) {      
      if ( vitesse1 > 0 ) {
        if (millis()> ( temps + delta_t)){
          temps = millis();
          vitesse1-- ;
          DCCpp::setSpeedMain(1, adresseLoco1, 128, vitesse1, ! sens1); 
        }
      }
      else { arretee1 = true ;}    
    }
    if ( arretee1 ) {
      if ( millis() < ( temps + tempsA )){ // on attend tempsA
      }
      else {                               //  tempsA écoulé, on repart
          etatLoco1 = 10 ;
      }
    }           
  }
  
  if  ( etatLoco1 == 10 )  {   // ==== etat 10 ====
    majOled();
    Gare1 = ! digitalRead(PIN_GARE1) ;  // ==== etat 10 ==== ON S'EST ARRETE APRES GARE1
    if ( vitesse1 < vitesse_min1 ) {
      if (millis()> ( temps + delta_t)){
        temps = millis();
        vitesse1++ ;
        arretee1 = false ;
        DCCpp::setSpeedMain(1, adresseLoco1, 128, vitesse1, sens1); // ==== etat 10 ==== ON REPART VERS GARE1 EN SENS NORMAL A PETITE VITESSE
      }  
    }
    else  {
      etatLoco1 = -1;                          // on repart pour un cycle        
    }
  } 
 // END LOCO 1

  
// ============================= LOCO 2 ==============================  
    
// etatLoco2 = 0
  if ( etatLoco2 == -1 ) {    // ==== etat -1 ==== ON LANCE L'AUTOMATE
    majOled();
    oled.setCursor(0, 0); // start of 1st line arret 
    oled.print(titre[6]); 
    if ( vitesse2 < vitesse_min2 ) {                     // on avance GARE1
      if (millis()> ( temps2 + delta_t)){
        temps2 = millis();
        vitesse2++ ;
        arretee2 = false ;
        DCCpp::setSpeedMain(1, adresseLoco2, 128, vitesse2, sens2); 
      }
    }
    else  etatLoco2 = 0  ;  
  } 
  if ( ( etatLoco2 == 0 ) || ( etatLoco2 == 1 ) ) {    // ==== etat 0 ==== ON VA S'ARRETER GARE2
    Gare2 = ! digitalRead(PIN_GARE2);          
    if ( Gare2 ) {etatLoco2 = 1;}    //  on est arrivé Gare1
    if ( etatLoco2 == 1 ) {            // on est passé sur PIN_GARE2
      if ( vitesse2 > 0 ) {
        if (millis()> ( temps2 + delta_t)){
          temps2 = millis();
          vitesse2-- ;
          DCCpp::setSpeedMain(1, adresseLoco2, 128, vitesse2, sens2); 
        }
      }
      else { arretee2 = true ;}    
    }
    if ( arretee2 ) {
      if ( millis() < ( temps2 + tempsA )){ // on attend tempsA
      }
      else {                               //  tempsA écoulé, on repart -> ZONEC 
        if ( etatLoco1 < 3 ) { 
          etatLoco2 = 2 ;
          DCCpp ::setAccessory(Address, SubAddress +1 ,  Activate);        // 2e aiguille déviée vers C   Addresse 6
        }
        Gare2 = ! digitalRead(PIN_GARE2); // ==== fin etat 1 ====  ON S ARRETE APRES GARE 2
      }
    }                          
  }  
      
// etatLoco2 = 2  
  if ( ( etatLoco2 == 2 ) || ( etatLoco2 == 3 ) ) {   // ==== etat 2 ==== GARE2 -> ZONEC   
    majOled();
    oled.setCursor(0, 0); // start of 1st line arret 
    oled.print(titre[6]); 
    if ( etatLoco2 == 2 ) {                             // on n'est pas encore  sur PIN_ZONEC
      if ( vitesse2 < vitesse_max2 ) {                     // on accélère
        if (millis()> ( temps2 + delta_t)){
          temps2 = millis();
          vitesse2++ ;
          arretee2 = false ;
          DCCpp::setSpeedMain(1, adresseLoco2, 128, vitesse2, sens2); 
        }
      }
    }
    ZoneC = ! digitalRead(PIN_ZONEC);    
    if ( ZoneC ) {etatLoco2 = 3;}
    if ( etatLoco2 == 3 ) {                        // on est passé sur PIN_ZONEC
      if ( vitesse2 > 0 ) {
        if (millis()> ( temps2 + delta_t)){
          temps2 = millis();
          vitesse2-- ;
          DCCpp::setSpeedMain(1, adresseLoco2, 128, vitesse2, sens2); 
        }
      }
      else { arretee2 = true ;}    
    }
    if ( arretee2 ) {
      if ( millis() < ( temps2 + tempsA )){ // on attend tempsA
      }
      else {                               //  tempsA écoulé, on repart vers Gare1
          if ( etatLoco1 >= 3 ) { 
            etatLoco2 = 4 ;
            DCCpp ::setAccessory(Address, SubAddress, Activate);        // 1ere aiguille déviée vers C   Addresse 5
          } 
          ZoneC = ! digitalRead(PIN_ZONEC); // ==== etat 4 ==== ON S'EST ARRETE APRES PIN_ZONEC
      }
    } 
  }
  
// etatLoco2 = 4
  if  ( ( etatLoco2 == 4 ) || ( etatLoco2 == 5 ) ) {   // ==== etat 4 ==== ZONEC -> GARE1
    majOled();
    if ( etatLoco2 == 4 ) {                             // on n'est pas encore  sur PIN_GARE1
      if ( vitesse2 < vitesse_max2 ) {                     // on accélère
        if (millis()> ( temps2 + delta_t)){
          temps2 = millis();
          vitesse2++ ;
          arretee2 = false ;
          DCCpp::setSpeedMain(1, adresseLoco2, 128, vitesse2, sens2); 
        }   
      }
    }
    Gare1 = ! digitalRead(PIN_GARE1);
    if ( Gare1 ) { etatLoco2 = 5 ; }
    if ( etatLoco2 == 5 ) {                            // on est passé sur PIN_GARE1
      if ( vitesse2 > 0 ) {                            // on ralentit
        if (millis()> ( temps2 + delta_t)){
          temps2 = millis();
          vitesse2-- ;
          DCCpp::setSpeedMain(1, adresseLoco2, 128, vitesse2, sens2); 
        }
      }
      else { arretee2 = true ;}    
    }
    if ( arretee2 ) {
      if ( millis() < ( temps2 + tempsA )){ // on attend tempsA
      }
      else {                               //  tempsA écoulé, on repart vers  ZoneA
        if ( etatLoco1 > 4 ) { 
           etatLoco2 = 6 ;
           DCCpp ::setAccessory(Address, SubAddress, ! Activate);       // 1ere aiguille directe vers A  Addresse 5
        } 
        Gare1 = ! digitalRead(PIN_GARE1);
      }
    }
  }
  
// etatLoco2 = 6
  if  ( ( etatLoco2 == 6 ) || ( etatLoco2 == 7 ) ) {   // ==== etat 5 ====  retour  GARE1 -> ZONEA
    majOled();
    if ( etatLoco2 == 6 ) {                             // on n'est pas encore
      if ( vitesse2 < vitesse_max2 ) {                     // on accélère
        if (millis()> ( temps2 + delta_t)){
          temps2 = millis();
          vitesse2++ ;
          arretee2 = false ;
          DCCpp::setSpeedMain(1, adresseLoco2, 128, vitesse2, ! sens2); 
        }
      }
    }
    ZoneA = ! digitalRead(PIN_ZONEA);
    if ( ZoneA ) { etatLoco2 = 7; }
    if ( etatLoco2 == 7 ) {                      // on est passé sur PIN_ZONEA et on s'arrête
      if ( vitesse2 > 0 ) {
        if (millis()> ( temps2 + delta_t)){
          temps2 = millis();
          vitesse2-- ;
          DCCpp::setSpeedMain(1, adresseLoco2, 128, vitesse2, ! sens2); 
        }
      }
      else { arretee2 = true ;}    
    }
    if ( arretee2 ) {
      if ( millis() < ( temps2 + tempsA )){ // on attend tempsA
      }
      else {                               //  tempsA écoulé, on repart -> GARE2
        if ( etatLoco1 > 6 ) {
          etatLoco2 = 8 ;
          DCCpp ::setAccessory(Address, SubAddress + 1, ! Activate);        // 2e aiguille directe vers A   Addresse 6
        }           
          
      }
        ZoneA = ! digitalRead(PIN_ZONEA);
    }
  }          



// etatLoco2 = 8
  if  ( ( etatLoco2 == 8 ) || ( etatLoco2 == 9 ) ) {   // ==== etat 8 ==== ZONEA -> GARE2
    majOled();
    if ( etatLoco2 == 8 ) {  
        Gare2 = ! digitalRead(PIN_GARE2) ; // ==== etat 8 ==== ON S'EST ARRETE APRES PIN_ZONEA ON REPART
        if ( vitesse2 < vitesse_max2 ) {
          if (millis()> ( temps2 + delta_t)){
            temps2 = millis();
            vitesse2++ ;
            arretee2 = false ;
            DCCpp::setSpeedMain(1, adresseLoco2, 128, vitesse2, ! sens2); 
          }   
       }
    }
    Gare2 = ! digitalRead(PIN_GARE2);// ==== etat 9 ==== ON EST ARRIVE GARE2 ON S'ARRETE
    if ( Gare2 ){etatLoco2 = 9 ;}          //  on est arrivé Gare2
    if ( etatLoco2 == 9 ) {      
      if ( vitesse2 > 0 ) {
        if (millis()> ( temps2 + delta_t)){
          temps2 = millis();
          vitesse2-- ;
          DCCpp::setSpeedMain(1, adresseLoco2, 128, vitesse2, ! sens2); 
        }
      }
      else { arretee2 = true ;}    
    }
    if ( arretee2 ) {
      if ( millis() < ( temps2 + tempsA )){ // on attend tempsA
      }
      else {                               //  tempsA écoulé, on repart
          etatLoco2 = 10 ;
      }
    }           
  }
  
  if  ( etatLoco2 == 10 )  {   // ==== etat 10 ====
    majOled();
    Gare2 = ! digitalRead(PIN_GARE2) ;  // ==== etat 10 ==== ON S'EST ARRETE APRES GARE2
    if ( vitesse2 < vitesse_min2 ) {
      if (millis()> ( temps2 + delta_t)){
        temps2 = millis();
        vitesse2++ ;
        arretee2 = false ;
        DCCpp::setSpeedMain(1, adresseLoco2, 128, vitesse2, sens2); // ==== etat 10 ==== ON REPART VERS GARE2 EN SENS OPPOSE A PETITE VITESSE
      }  
    }
    else  {
      etatLoco2 = -1;                          // on repart pour un cycle        
    }
  } 
 // END LOCO 2 
 
} // END LOOP
